structure AtkLayer :>
  sig
    include ATK_LAYER
  end =
  struct
    datatype t =
      INVALID
    | BACKGROUND
    | CANVAS
    | WIDGET
    | MDI
    | POPUP
    | OVERLAY
    | WINDOW
    structure C =
      struct
        type val_ = FFI.Enum.val_
        type ref_ = FFI.Enum.ref_
        exception Value of FFI.Enum.val_
        fun withVal f =
          fn
            INVALID => f 0
          | BACKGROUND => f 1
          | CANVAS => f 2
          | WIDGET => f 3
          | MDI => f 4
          | POPUP => f 5
          | OVERLAY => f 6
          | WINDOW => f 7
        fun withRefVal f = withVal (FFI.Enum.withRef f)
        val fromVal =
          fn
            0 => INVALID
          | 1 => BACKGROUND
          | 2 => CANVAS
          | 3 => WIDGET
          | 4 => MDI
          | 5 => POPUP
          | 6 => OVERLAY
          | 7 => WINDOW
          | n => raise Value n
      end
    val getType_ = _import "atk_layer_get_type" : unit -> GObjectType.C.val_;
    val getValue_ = _import "g_value_get_enum" : GObjectValueRecord.C.notnull GObjectValueRecord.C.p -> C.val_;
    val setValue_ = fn x1 & x2 => (_import "g_value_set_enum" : GObjectValueRecord.C.notnull GObjectValueRecord.C.p * C.val_ -> unit;) (x1, x2)
    val t =
      GObjectValue.C.createAccessor
        {
          getType = (I ---> GObjectType.C.fromVal) getType_,
          getValue = (I ---> C.fromVal) getValue_,
          setValue = (I &&&> C.withVal ---> I) setValue_
        }
    val null = INVALID
    val getType = (I ---> GObjectType.C.fromVal) getType_
  end
