structure GObjectTypeModule :>
  G_OBJECT_TYPE_MODULE
    where type 'a class_t = 'a GObjectTypeModuleClass.t
    where type 'a typepluginclass_t = 'a GObjectTypePluginClass.t
    where type type_t = GObjectType.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (load_sym libgobject "g_type_module_get_type") (FFI.PolyML.VOID --> GObjectType.PolyML.VAL)
      val setName_ = call (load_sym libgobject "g_type_module_set_name") (GObjectObjectClass.PolyML.PTR &&> FFI.PolyML.String.INPTR --> FFI.PolyML.VOID)
      val unuse_ = call (load_sym libgobject "g_type_module_unuse") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.VOID)
      val use_ = call (load_sym libgobject "g_type_module_use") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Bool.VAL)
    end
    type 'a class_t = 'a GObjectTypeModuleClass.t
    type 'a typepluginclass_t = 'a GObjectTypePluginClass.t
    type type_t = GObjectType.t
    fun asTypePlugin self = (GObjectObjectClass.C.withPtr ---> GObjectTypePluginClass.C.fromPtr false) I self
    val getType = (I ---> GObjectType.C.fromVal) getType_
    fun setName self name = (GObjectObjectClass.C.withPtr &&&> FFI.String.withConstPtr ---> I) setName_ (self & name)
    fun unuse self = (GObjectObjectClass.C.withPtr ---> I) unuse_ self
    fun use self = (GObjectObjectClass.C.withPtr ---> FFI.Bool.fromVal) use_ self
  end
