structure GtkIconViewDropPosition :>
  sig
    include GTK_ICON_VIEW_DROP_POSITION
    structure PolyML :
      sig
        val VAL : C.val_ CInterface.Conversion
        val REF : C.ref_ CInterface.Conversion
      end
  end =
  struct
    datatype t =
      NODROP
    | DROPINTO
    | DROPLEFT
    | DROPRIGHT
    | DROPABOVE
    | DROPBELOW
    structure C =
      struct
        type val_ = FFI.Enum.val_
        type ref_ = FFI.Enum.ref_
        exception Value of FFI.Enum.val_
        fun withVal f =
          fn
            NODROP => f 0
          | DROPINTO => f 1
          | DROPLEFT => f 2
          | DROPRIGHT => f 3
          | DROPABOVE => f 4
          | DROPBELOW => f 5
        fun withRefVal f = withVal (FFI.Enum.withRef f)
        val fromVal =
          fn
            0 => NODROP
          | 1 => DROPINTO
          | 2 => DROPLEFT
          | 3 => DROPRIGHT
          | 4 => DROPABOVE
          | 5 => DROPBELOW
          | n => raise Value n
      end
    structure PolyML =
      struct
        val VAL = FFI.PolyML.Enum.VAL
        val REF = FFI.PolyML.Enum.REF
      end
    local
      open PolyMLFFI
    in
      val getType_ = call (load_sym libgtk "gtk_icon_view_drop_position_get_type") (FFI.PolyML.VOID --> GObjectType.PolyML.VAL)
      val getValue_ = call (load_sym libgobject "g_value_get_enum") (GObjectValueRecord.PolyML.PTR --> PolyML.VAL)
      val setValue_ = call (load_sym libgobject "g_value_set_enum") (GObjectValueRecord.PolyML.PTR &&> PolyML.VAL --> FFI.PolyML.VOID)
    end
    val t =
      GObjectValue.C.createAccessor
        {
          getType = (I ---> GObjectType.C.fromVal) getType_,
          getValue = (I ---> C.fromVal) getValue_,
          setValue = (I &&&> C.withVal ---> I) setValue_
        }
    val null = NODROP
    val getType = (I ---> GObjectType.C.fromVal) getType_
  end
