structure PangoLayout :>
  PANGO_LAYOUT
    where type 'a class_t = 'a PangoLayoutClass.t
    where type attrlistrecord_t = PangoAttrListRecord.t
    where type 'a contextclass_t = 'a PangoContextClass.t
    where type layoutiterrecord_t = PangoLayoutIterRecord.t
    where type layoutlinerecord_t = PangoLayoutLineRecord.t
    where type rectanglerecord_t = PangoRectangleRecord.t
    where type alignment_t = PangoAlignment.t
    where type ellipsizemode_t = PangoEllipsizeMode.t
    where type fontdescriptionrecord_t = PangoFontDescriptionRecord.t
    where type tabarrayrecord_t = PangoTabArrayRecord.t
    where type wrapmode_t = PangoWrapMode.t =
  struct
    local
      open PolyMLFFI
    in
      val getType_ = call (load_sym libpango "pango_layout_get_type") (FFI.PolyML.VOID --> GObjectType.PolyML.VAL)
      val new_ = call (load_sym libpango "pango_layout_new") (GObjectObjectClass.PolyML.PTR --> GObjectObjectClass.PolyML.PTR)
      val contextChanged_ = call (load_sym libpango "pango_layout_context_changed") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.VOID)
      val copy_ = call (load_sym libpango "pango_layout_copy") (GObjectObjectClass.PolyML.PTR --> GObjectObjectClass.PolyML.PTR)
      val getAlignment_ = call (load_sym libpango "pango_layout_get_alignment") (GObjectObjectClass.PolyML.PTR --> PangoAlignment.PolyML.VAL)
      val getAttributes_ = call (load_sym libpango "pango_layout_get_attributes") (GObjectObjectClass.PolyML.PTR --> PangoAttrListRecord.PolyML.PTR)
      val getAutoDir_ = call (load_sym libpango "pango_layout_get_auto_dir") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Bool.VAL)
      val getBaseline_ = call (load_sym libpango "pango_layout_get_baseline") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Int32.VAL)
      val getCharacterCount_ = call (load_sym libpango "pango_layout_get_character_count") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Int32.VAL)
      val getContext_ = call (load_sym libpango "pango_layout_get_context") (GObjectObjectClass.PolyML.PTR --> GObjectObjectClass.PolyML.PTR)
      val getCursorPos_ =
        call (load_sym libpango "pango_layout_get_cursor_pos")
          (
            GObjectObjectClass.PolyML.PTR
             &&> FFI.PolyML.Int32.VAL
             &&> PangoRectangleRecord.PolyML.PTR
             &&> PangoRectangleRecord.PolyML.PTR
             --> FFI.PolyML.VOID
          )
      val getEllipsize_ = call (load_sym libpango "pango_layout_get_ellipsize") (GObjectObjectClass.PolyML.PTR --> PangoEllipsizeMode.PolyML.VAL)
      val getExtents_ =
        call (load_sym libpango "pango_layout_get_extents")
          (
            GObjectObjectClass.PolyML.PTR
             &&> PangoRectangleRecord.PolyML.PTR
             &&> PangoRectangleRecord.PolyML.PTR
             --> FFI.PolyML.VOID
          )
      val getFontDescription_ = call (load_sym libpango "pango_layout_get_font_description") (GObjectObjectClass.PolyML.PTR --> PangoFontDescriptionRecord.PolyML.PTR)
      val getHeight_ = call (load_sym libpango "pango_layout_get_height") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Int32.VAL)
      val getIndent_ = call (load_sym libpango "pango_layout_get_indent") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Int32.VAL)
      val getIter_ = call (load_sym libpango "pango_layout_get_iter") (GObjectObjectClass.PolyML.PTR --> PangoLayoutIterRecord.PolyML.PTR)
      val getJustify_ = call (load_sym libpango "pango_layout_get_justify") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Bool.VAL)
      val getLine_ = call (load_sym libpango "pango_layout_get_line") (GObjectObjectClass.PolyML.PTR &&> FFI.PolyML.Int32.VAL --> PangoLayoutLineRecord.PolyML.PTR)
      val getLineCount_ = call (load_sym libpango "pango_layout_get_line_count") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Int32.VAL)
      val getLineReadonly_ = call (load_sym libpango "pango_layout_get_line_readonly") (GObjectObjectClass.PolyML.PTR &&> FFI.PolyML.Int32.VAL --> PangoLayoutLineRecord.PolyML.PTR)
      val getPixelExtents_ =
        call (load_sym libpango "pango_layout_get_pixel_extents")
          (
            GObjectObjectClass.PolyML.PTR
             &&> PangoRectangleRecord.PolyML.PTR
             &&> PangoRectangleRecord.PolyML.PTR
             --> FFI.PolyML.VOID
          )
      val getPixelSize_ =
        call (load_sym libpango "pango_layout_get_pixel_size")
          (
            GObjectObjectClass.PolyML.PTR
             &&> FFI.PolyML.Int32.REF
             &&> FFI.PolyML.Int32.REF
             --> FFI.PolyML.VOID
          )
      val getSingleParagraphMode_ = call (load_sym libpango "pango_layout_get_single_paragraph_mode") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Bool.VAL)
      val getSize_ =
        call (load_sym libpango "pango_layout_get_size")
          (
            GObjectObjectClass.PolyML.PTR
             &&> FFI.PolyML.Int32.REF
             &&> FFI.PolyML.Int32.REF
             --> FFI.PolyML.VOID
          )
      val getSpacing_ = call (load_sym libpango "pango_layout_get_spacing") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Int32.VAL)
      val getTabs_ = call (load_sym libpango "pango_layout_get_tabs") (GObjectObjectClass.PolyML.PTR --> PangoTabArrayRecord.PolyML.PTR)
      val getText_ = call (load_sym libpango "pango_layout_get_text") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.String.RETPTR)
      val getUnknownGlyphsCount_ = call (load_sym libpango "pango_layout_get_unknown_glyphs_count") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Int32.VAL)
      val getWidth_ = call (load_sym libpango "pango_layout_get_width") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Int32.VAL)
      val getWrap_ = call (load_sym libpango "pango_layout_get_wrap") (GObjectObjectClass.PolyML.PTR --> PangoWrapMode.PolyML.VAL)
      val indexToLineX_ =
        call (load_sym libpango "pango_layout_index_to_line_x")
          (
            GObjectObjectClass.PolyML.PTR
             &&> FFI.PolyML.Int32.VAL
             &&> FFI.PolyML.Bool.VAL
             &&> FFI.PolyML.Int32.REF
             &&> FFI.PolyML.Int32.REF
             --> FFI.PolyML.VOID
          )
      val indexToPos_ =
        call (load_sym libpango "pango_layout_index_to_pos")
          (
            GObjectObjectClass.PolyML.PTR
             &&> FFI.PolyML.Int32.VAL
             &&> PangoRectangleRecord.PolyML.PTR
             --> FFI.PolyML.VOID
          )
      val isEllipsized_ = call (load_sym libpango "pango_layout_is_ellipsized") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Bool.VAL)
      val isWrapped_ = call (load_sym libpango "pango_layout_is_wrapped") (GObjectObjectClass.PolyML.PTR --> FFI.PolyML.Bool.VAL)
      val setAlignment_ = call (load_sym libpango "pango_layout_set_alignment") (GObjectObjectClass.PolyML.PTR &&> PangoAlignment.PolyML.VAL --> FFI.PolyML.VOID)
      val setAutoDir_ = call (load_sym libpango "pango_layout_set_auto_dir") (GObjectObjectClass.PolyML.PTR &&> FFI.PolyML.Bool.VAL --> FFI.PolyML.VOID)
      val setEllipsize_ = call (load_sym libpango "pango_layout_set_ellipsize") (GObjectObjectClass.PolyML.PTR &&> PangoEllipsizeMode.PolyML.VAL --> FFI.PolyML.VOID)
      val setFontDescription_ = call (load_sym libpango "pango_layout_set_font_description") (GObjectObjectClass.PolyML.PTR &&> PangoFontDescriptionRecord.PolyML.OPTPTR --> FFI.PolyML.VOID)
      val setHeight_ = call (load_sym libpango "pango_layout_set_height") (GObjectObjectClass.PolyML.PTR &&> FFI.PolyML.Int32.VAL --> FFI.PolyML.VOID)
      val setIndent_ = call (load_sym libpango "pango_layout_set_indent") (GObjectObjectClass.PolyML.PTR &&> FFI.PolyML.Int32.VAL --> FFI.PolyML.VOID)
      val setJustify_ = call (load_sym libpango "pango_layout_set_justify") (GObjectObjectClass.PolyML.PTR &&> FFI.PolyML.Bool.VAL --> FFI.PolyML.VOID)
      val setMarkup_ =
        call (load_sym libpango "pango_layout_set_markup")
          (
            GObjectObjectClass.PolyML.PTR
             &&> FFI.PolyML.String.INPTR
             &&> FFI.PolyML.Int32.VAL
             --> FFI.PolyML.VOID
          )
      val setMarkupWithAccel_ =
        call (load_sym libpango "pango_layout_set_markup_with_accel")
          (
            GObjectObjectClass.PolyML.PTR
             &&> FFI.PolyML.String.INPTR
             &&> FFI.PolyML.Int32.VAL
             &&> FFI.PolyML.Char.VAL
             &&> FFI.PolyML.Char.REF
             --> FFI.PolyML.VOID
          )
      val setSingleParagraphMode_ = call (load_sym libpango "pango_layout_set_single_paragraph_mode") (GObjectObjectClass.PolyML.PTR &&> FFI.PolyML.Bool.VAL --> FFI.PolyML.VOID)
      val setSpacing_ = call (load_sym libpango "pango_layout_set_spacing") (GObjectObjectClass.PolyML.PTR &&> FFI.PolyML.Int32.VAL --> FFI.PolyML.VOID)
      val setTabs_ = call (load_sym libpango "pango_layout_set_tabs") (GObjectObjectClass.PolyML.PTR &&> PangoTabArrayRecord.PolyML.OPTPTR --> FFI.PolyML.VOID)
      val setText_ =
        call (load_sym libpango "pango_layout_set_text")
          (
            GObjectObjectClass.PolyML.PTR
             &&> FFI.PolyML.String.INPTR
             &&> FFI.PolyML.Int32.VAL
             --> FFI.PolyML.VOID
          )
      val setWidth_ = call (load_sym libpango "pango_layout_set_width") (GObjectObjectClass.PolyML.PTR &&> FFI.PolyML.Int32.VAL --> FFI.PolyML.VOID)
      val setWrap_ = call (load_sym libpango "pango_layout_set_wrap") (GObjectObjectClass.PolyML.PTR &&> PangoWrapMode.PolyML.VAL --> FFI.PolyML.VOID)
      val xyToIndex_ =
        call (load_sym libpango "pango_layout_xy_to_index")
          (
            GObjectObjectClass.PolyML.PTR
             &&> FFI.PolyML.Int32.VAL
             &&> FFI.PolyML.Int32.VAL
             &&> FFI.PolyML.Int32.REF
             &&> FFI.PolyML.Int32.REF
             --> FFI.PolyML.Bool.VAL
          )
    end
    type 'a class_t = 'a PangoLayoutClass.t
    type attrlistrecord_t = PangoAttrListRecord.t
    type 'a contextclass_t = 'a PangoContextClass.t
    type layoutiterrecord_t = PangoLayoutIterRecord.t
    type layoutlinerecord_t = PangoLayoutLineRecord.t
    type rectanglerecord_t = PangoRectangleRecord.t
    type alignment_t = PangoAlignment.t
    type ellipsizemode_t = PangoEllipsizeMode.t
    type fontdescriptionrecord_t = PangoFontDescriptionRecord.t
    type tabarrayrecord_t = PangoTabArrayRecord.t
    type wrapmode_t = PangoWrapMode.t
    val getType = (I ---> GObjectType.C.fromVal) getType_
    fun new context = (GObjectObjectClass.C.withPtr ---> PangoLayoutClass.C.fromPtr true) new_ context
    fun contextChanged self = (GObjectObjectClass.C.withPtr ---> I) contextChanged_ self
    fun copy self = (GObjectObjectClass.C.withPtr ---> PangoLayoutClass.C.fromPtr true) copy_ self
    fun getAlignment self = (GObjectObjectClass.C.withPtr ---> PangoAlignment.C.fromVal) getAlignment_ self
    fun getAttributes self = (GObjectObjectClass.C.withPtr ---> PangoAttrListRecord.C.fromPtr true) getAttributes_ self
    fun getAutoDir self = (GObjectObjectClass.C.withPtr ---> FFI.Bool.fromVal) getAutoDir_ self
    fun getBaseline self = (GObjectObjectClass.C.withPtr ---> FFI.Int32.fromVal) getBaseline_ self
    fun getCharacterCount self = (GObjectObjectClass.C.withPtr ---> FFI.Int32.fromVal) getCharacterCount_ self
    fun getContext self = (GObjectObjectClass.C.withPtr ---> PangoContextClass.C.fromPtr false) getContext_ self
    fun getCursorPos self index =
      let
        val strongPos
         & weakPos
         & () =
          (
            GObjectObjectClass.C.withPtr
             &&&> FFI.Int32.withVal
             &&&> PangoRectangleRecord.C.withNewPtr
             &&&> PangoRectangleRecord.C.withNewPtr
             ---> PangoRectangleRecord.C.fromPtr true
                   && PangoRectangleRecord.C.fromPtr true
                   && I
          )
            getCursorPos_
            (
              self
               & index
               & ()
               & ()
            )
      in
        (strongPos, weakPos)
      end
    fun getEllipsize self = (GObjectObjectClass.C.withPtr ---> PangoEllipsizeMode.C.fromVal) getEllipsize_ self
    fun getExtents self =
      let
        val inkRect
         & logicalRect
         & () =
          (
            GObjectObjectClass.C.withPtr
             &&&> PangoRectangleRecord.C.withNewPtr
             &&&> PangoRectangleRecord.C.withNewPtr
             ---> PangoRectangleRecord.C.fromPtr true
                   && PangoRectangleRecord.C.fromPtr true
                   && I
          )
            getExtents_
            (
              self
               & ()
               & ()
            )
      in
        (inkRect, logicalRect)
      end
    fun getFontDescription self = (GObjectObjectClass.C.withPtr ---> PangoFontDescriptionRecord.C.fromPtr false) getFontDescription_ self
    fun getHeight self = (GObjectObjectClass.C.withPtr ---> FFI.Int32.fromVal) getHeight_ self
    fun getIndent self = (GObjectObjectClass.C.withPtr ---> FFI.Int32.fromVal) getIndent_ self
    fun getIter self = (GObjectObjectClass.C.withPtr ---> PangoLayoutIterRecord.C.fromPtr true) getIter_ self
    fun getJustify self = (GObjectObjectClass.C.withPtr ---> FFI.Bool.fromVal) getJustify_ self
    fun getLine self line = (GObjectObjectClass.C.withPtr &&&> FFI.Int32.withVal ---> PangoLayoutLineRecord.C.fromPtr true) getLine_ (self & line)
    fun getLineCount self = (GObjectObjectClass.C.withPtr ---> FFI.Int32.fromVal) getLineCount_ self
    fun getLineReadonly self line = (GObjectObjectClass.C.withPtr &&&> FFI.Int32.withVal ---> PangoLayoutLineRecord.C.fromPtr true) getLineReadonly_ (self & line)
    fun getPixelExtents self =
      let
        val inkRect
         & logicalRect
         & () =
          (
            GObjectObjectClass.C.withPtr
             &&&> PangoRectangleRecord.C.withNewPtr
             &&&> PangoRectangleRecord.C.withNewPtr
             ---> PangoRectangleRecord.C.fromPtr true
                   && PangoRectangleRecord.C.fromPtr true
                   && I
          )
            getPixelExtents_
            (
              self
               & ()
               & ()
            )
      in
        (inkRect, logicalRect)
      end
    fun getPixelSize self =
      let
        val width
         & height
         & () =
          (
            GObjectObjectClass.C.withPtr
             &&&> FFI.Int32.withRefVal
             &&&> FFI.Int32.withRefVal
             ---> FFI.Int32.fromVal
                   && FFI.Int32.fromVal
                   && I
          )
            getPixelSize_
            (
              self
               & 0
               & 0
            )
      in
        (width, height)
      end
    fun getSingleParagraphMode self = (GObjectObjectClass.C.withPtr ---> FFI.Bool.fromVal) getSingleParagraphMode_ self
    fun getSize self =
      let
        val width
         & height
         & () =
          (
            GObjectObjectClass.C.withPtr
             &&&> FFI.Int32.withRefNewVal
             &&&> FFI.Int32.withRefNewVal
             ---> FFI.Int32.fromVal
                   && FFI.Int32.fromVal
                   && I
          )
            getSize_
            (
              self
               & 0
               & 0
            )
      in
        (width, height)
      end
    fun getSpacing self = (GObjectObjectClass.C.withPtr ---> FFI.Int32.fromVal) getSpacing_ self
    fun getTabs self = (GObjectObjectClass.C.withPtr ---> PangoTabArrayRecord.C.fromPtr true) getTabs_ self
    fun getText self = (GObjectObjectClass.C.withPtr ---> FFI.String.fromPtr false) getText_ self
    fun getUnknownGlyphsCount self = (GObjectObjectClass.C.withPtr ---> FFI.Int32.fromVal) getUnknownGlyphsCount_ self
    fun getWidth self = (GObjectObjectClass.C.withPtr ---> FFI.Int32.fromVal) getWidth_ self
    fun getWrap self = (GObjectObjectClass.C.withPtr ---> PangoWrapMode.C.fromVal) getWrap_ self
    fun indexToLineX self index trailing =
      let
        val line
         & xPos
         & () =
          (
            GObjectObjectClass.C.withPtr
             &&&> FFI.Int32.withVal
             &&&> FFI.Bool.withVal
             &&&> FFI.Int32.withRefVal
             &&&> FFI.Int32.withRefVal
             ---> FFI.Int32.fromVal
                   && FFI.Int32.fromVal
                   && I
          )
            indexToLineX_
            (
              self
               & index
               & trailing
               & 0
               & 0
            )
      in
        (line, xPos)
      end
    fun indexToPos self index =
      let
        val pos & () =
          (
            GObjectObjectClass.C.withPtr
             &&&> FFI.Int32.withVal
             &&&> PangoRectangleRecord.C.withNewPtr
             ---> PangoRectangleRecord.C.fromPtr true && I
          )
            indexToPos_
            (
              self
               & index
               & ()
            )
      in
        pos
      end
    fun isEllipsized self = (GObjectObjectClass.C.withPtr ---> FFI.Bool.fromVal) isEllipsized_ self
    fun isWrapped self = (GObjectObjectClass.C.withPtr ---> FFI.Bool.fromVal) isWrapped_ self
    fun setAlignment self alignment = (GObjectObjectClass.C.withPtr &&&> PangoAlignment.C.withVal ---> I) setAlignment_ (self & alignment)
    fun setAutoDir self autoDir = (GObjectObjectClass.C.withPtr &&&> FFI.Bool.withVal ---> I) setAutoDir_ (self & autoDir)
    fun setEllipsize self ellipsize = (GObjectObjectClass.C.withPtr &&&> PangoEllipsizeMode.C.withVal ---> I) setEllipsize_ (self & ellipsize)
    fun setFontDescription self desc = (GObjectObjectClass.C.withPtr &&&> PangoFontDescriptionRecord.C.withOptPtr ---> I) setFontDescription_ (self & desc)
    fun setHeight self height = (GObjectObjectClass.C.withPtr &&&> FFI.Int32.withVal ---> I) setHeight_ (self & height)
    fun setIndent self indent = (GObjectObjectClass.C.withPtr &&&> FFI.Int32.withVal ---> I) setIndent_ (self & indent)
    fun setJustify self justify = (GObjectObjectClass.C.withPtr &&&> FFI.Bool.withVal ---> I) setJustify_ (self & justify)
    fun setMarkup self markup length =
      (
        GObjectObjectClass.C.withPtr
         &&&> FFI.String.withConstPtr
         &&&> FFI.Int32.withVal
         ---> I
      )
        setMarkup_
        (
          self
           & markup
           & length
        )
    fun setMarkupWithAccel self markup length accelMarker =
      let
        val accelChar & () =
          (
            GObjectObjectClass.C.withPtr
             &&&> FFI.String.withConstPtr
             &&&> FFI.Int32.withVal
             &&&> FFI.Char.withVal
             &&&> FFI.Char.withRefNewVal
             ---> FFI.Char.fromVal && I
          )
            setMarkupWithAccel_
            (
              self
               & markup
               & length
               & accelMarker
               & #"\^@"
            )
      in
        accelChar
      end
    fun setSingleParagraphMode self setting = (GObjectObjectClass.C.withPtr &&&> FFI.Bool.withVal ---> I) setSingleParagraphMode_ (self & setting)
    fun setSpacing self spacing = (GObjectObjectClass.C.withPtr &&&> FFI.Int32.withVal ---> I) setSpacing_ (self & spacing)
    fun setTabs self tabs = (GObjectObjectClass.C.withPtr &&&> PangoTabArrayRecord.C.withOptPtr ---> I) setTabs_ (self & tabs)
    fun setText self text length =
      (
        GObjectObjectClass.C.withPtr
         &&&> FFI.String.withConstPtr
         &&&> FFI.Int32.withVal
         ---> I
      )
        setText_
        (
          self
           & text
           & length
        )
    fun setWidth self width = (GObjectObjectClass.C.withPtr &&&> FFI.Int32.withVal ---> I) setWidth_ (self & width)
    fun setWrap self wrap = (GObjectObjectClass.C.withPtr &&&> PangoWrapMode.C.withVal ---> I) setWrap_ (self & wrap)
    fun xyToIndex self x y =
      let
        val index
         & trailing
         & retVal =
          (
            GObjectObjectClass.C.withPtr
             &&&> FFI.Int32.withVal
             &&&> FFI.Int32.withVal
             &&&> FFI.Int32.withRefVal
             &&&> FFI.Int32.withRefVal
             ---> FFI.Int32.fromVal
                   && FFI.Int32.fromVal
                   && FFI.Bool.fromVal
          )
            xyToIndex_
            (
              self
               & x
               & y
               & 0
               & 0
            )
      in
        if retVal then SOME (index, trailing) else NONE
      end
  end
